VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4575
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9690
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4575
   ScaleWidth      =   9690
   Begin VB.CommandButton cmd 
      Caption         =   "Zeichenfolge senden"
      Enabled         =   0   'False
      Height          =   615
      Index           =   2
      Left            =   5040
      TabIndex        =   7
      Top             =   120
      Width           =   2055
   End
   Begin VB.CheckBox chk 
      Caption         =   "Textablage zeigen"
      Height          =   495
      Index           =   1
      Left            =   2400
      Style           =   1  'Graphical
      TabIndex        =   6
      Top             =   3960
      Width           =   2055
   End
   Begin VB.CheckBox chk 
      Caption         =   "Immer im Vordergrund"
      Height          =   495
      Index           =   0
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   3960
      Width           =   2055
   End
   Begin VB.Frame fra 
      Caption         =   "Programmstatus"
      Height          =   3015
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   9495
      Begin VB.TextBox txtStatus 
         BackColor       =   &H00C0FFFF&
         Height          =   2655
         Left            =   120
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   4
         Top             =   240
         Width           =   9255
      End
   End
   Begin VB.CommandButton cmd 
      Caption         =   "Beenden"
      Height          =   615
      Index           =   3
      Left            =   7560
      TabIndex        =   2
      Top             =   120
      Width           =   2055
   End
   Begin VB.CommandButton cmd 
      Caption         =   "Starte Befehlsabarbeitung"
      Enabled         =   0   'False
      Height          =   615
      Index           =   1
      Left            =   2640
      TabIndex        =   1
      Top             =   120
      Width           =   2055
   End
   Begin VB.CommandButton cmd 
      Caption         =   "Starte DOS Programm"
      Height          =   615
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private DOSProgram As String, hDOS As Long, WindowTitle As String
 
Private Sub chk_Click(Index As Integer)
'.------------------------------------------------------------------------------
'.  Funktion :  Auswahl, ob das Hauptfenster immer im Vordergrund gehalten
'.              werden soll oder nicht und ob die Textablage angezeigt werden
'.              soll oder nicht.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: Index - Index der CheckBox
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Select Case Index
  Case 0:
   If chk(0).Value = 1 Then
     SetForeground Me.hwnd, True
    Else
     SetForeground Me.hwnd, False
   End If
  Case 1:
   If chk(1).Value = 1 Then
     frmText.Visible = True
    Else
     frmText.Visible = False
   End If
 End Select
End Sub

Private Sub cmd_Click(Index As Integer)
'.------------------------------------------------------------------------------
'.  Funktion : Auswahl zum Progamm
'.             Starte DOS Programm - Startet das ausgewhlte Beispiel.
'.             Starte Befehlsabarbeitung - Startet die Befehlsabarbeitung fr das
'.                                         gewhlte Beispiel
'.             Zeichenfolge senden - sendet eine einzelne Zeichenfolge an das
'.                                   Programm
'.             Beenden - Beendet das Programm, aber nicht das DOS-Programm.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: Index - Index des CommandButtons
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim KeyWaitMilliSeconds As Long, i As Long, comStr As String
 KeyWaitMilliSeconds = 350
 Select Case Index
  Case 0:
   If DOSProgramIsRunning(DOSProgram) = True Then
    MsgBox "Es luft bereits eine Instanz des DOS-Programmes!" & vbCrLf & _
     "Bitte beenden Sie diese erst.", vbExclamation
    Exit Sub
   End If
   Screen.MousePointer = vbHourglass: DoEvents
   ' 3 Sekunden Wartezeit geben, das sollte auch fr langsame Rechner gengen.
   StartDOSProgram DOSProgram, WindowTitle, NormalFocus, 3000, Me
   Screen.MousePointer = vbNormal
   cmd(0).Enabled = False
   cmd(1).Enabled = True
   cmd(2).Enabled = True
  Case 1:
   cmd(1).Enabled = False
   Screen.MousePointer = vbHourglass
   
   chk(1).Value = 1
   Select Case Sample
    Case 1:
     For i = 1 To 2
      Status "Adresse " & i & " aufrufen."
      mSendDOSString "Adr{Enter}" & i, 2 * KeyWaitMilliSeconds
      Status "Kopiere kompletten Bildschirm"
      If IsWinNT = True Then
        AddToText CopyCompleteDOSScreen(2 * KeyWaitMilliSeconds)
       Else
        AddToText CopyDOSScreen(1, 1, 80, 28, 2 * KeyWaitMilliSeconds)
      End If
      mSendDOSString "5", KeyWaitMilliSeconds
     Next i
     Status "Fertig"
    Case 2:
     Status "Einen Text an das DOS-Programm senden."
     mSendDOSString "Text erstellt mit: " & App.ProductName & "{Enter}", KeyWaitMilliSeconds
     mSendDOSString ReplaceSendkeyCommands("Steuerzeichen: +^%{Enter}"), KeyWaitMilliSeconds
     mSendDOSString ("Umlaute: {Enter}"), KeyWaitMilliSeconds
   
     mSendDOSString "{F1}", 2 * KeyWaitMilliSeconds
   
     Status "Kopiere Hilfebildschirm"
     AddToText CopyDOSScreen(8, 5, 66, 14, 2 * KeyWaitMilliSeconds)
     
     mSendDOSString "{ESC}", KeyWaitMilliSeconds
     Status "Den ganzen kopierten Inhalt an Edit schicken."
     mSendDOSString ReplaceSendkeyCommands(frmText.txt.Text), KeyWaitMilliSeconds, False
   
     Status "Das Programm beenden und die Datei unter 'Edit.txt' speichern."
     mSendDOSString "%D", 3 * KeyWaitMilliSeconds
     If IsWinNT = False Then
      ' Unter Win98 muss ein 2. 'D' gesendet werden
      mSendDOSString "D", 3 * KeyWaitMilliSeconds
     End If
     mSendDOSString "BJ", 3 * KeyWaitMilliSeconds
     If Dir(App.Path & "\edit.txt") <> "" Then
      Kill App.Path & "\edit.txt"
     End If
     mSendDOSString "Edit.txt", KeyWaitMilliSeconds
     mSendDOSString "{Enter}", KeyWaitMilliSeconds
     Status "Fertig"
   End Select
   Screen.MousePointer = vbNormal
  Case 2:
   comStr = InputBox("Bitte geben Sie einen einzelnen String ein, der an das DOS-Programm gesendet werden soll", "Einzel-String senden", LastStr)
   If Len(comStr) > 0 Then
    If UCase$(comStr) = "SYSMARK" Then
      AppActivate TaskID
      SetDOSMark
     Else
      mSendDOSString comStr, KeyWaitMilliSeconds
    End If
    LastStr = comStr
   End If
   Screen.MousePointer = vbNormal
  Case 3:
   Unload Me
   End
 End Select
End Sub

Private Sub Form_Load()
'.------------------------------------------------------------------------------
'.  Funktion : Ldt das Hauptformular und nimmt die Initialierung des Programms
'.             vor. Ruft die Auswahl der Beispiele auf
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: -
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Clipboard.Clear
 frmChoice.Show vbModal, Me
 Select Case Sample
  Case 1:
   DOSProgram = "C:\Fibu\lief-adr.exe"
   If Dir(DOSProgram) = "" Then
    MsgBox "Das Beispielprogramm konnte nicht gefunden werden!" & vbCrLf & _
     "Bitte lesen Sie in den Ausschreibung nach, wie man dieses installiert." & vbCrLf & vbCrLf & _
     "Das Programm wird abgebrochen.", vbCritical
    End
   End If
   If IsWinNT Then
     WindowTitle = DOSProgram
    Else
     WindowTitle = Mid$(DOSProgram, InStrRevVB5(DOSProgram, "\") + 1, InStrRevVB5(DOSProgram, ".") - InStrRevVB5(DOSProgram, "\") - 1)
   End If
   Me.Caption = App.ProductName & " [" & App.Major & "." & App.Minor & "." & App.Revision & "] - " & _
    "Fibu Beispiel"
  Case 2:
   DOSProgram = GetSystempath & "edit.com"
   If Dir(DOSProgram) = "" Then
    DOSProgram = GetWindowspath & "\command\edit.com"
    If Dir(DOSProgram) = "" Then
     MsgBox "Das Programm 'edit.com' konnte nicht gefunden werden!" & vbCrLf & _
      "Diese Beispiel kann nicht demonstriert werden." & vbCrLf & vbCrLf & _
      "Das Programm wird abgebrochen.", vbCritical
     End
    End If
   End If
   If IsWinNT Then
     WindowTitle = DOSProgram
    Else
     WindowTitle = "MS-DOS-Editor"
   End If
   Me.Caption = App.ProductName & " [" & App.Major & "." & App.Minor & "." & App.Revision & "] - " & _
    "Edit Beispiel"
  Case Else
   MsgBox "Das Programm wird beendet.", vbExclamation
   Unload Me
   End
 End Select
  
 With Me
  .Top = 0
  .Left = (Screen.Width - .Width)
 End With
 
 CheckKeybordState
 
 chk(0).Value = 1
End Sub

Private Sub AddToText(txt As String)
'.------------------------------------------------------------------------------
'.  Funktion : Fgt einen Text in die Textablage ein.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: txt - Text der eingefgt werden soll
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 With frmText.txt
  If Len(.Text) = 0 Then
    .Text = txt
   Else
    .Text = .Text & vbCrLf & txt
    .SelStart = Len(.Text)
  End If
 End With
End Sub

Private Sub mSendDOSString(DOSString As String, Optional KeyWaitMilliSeconds As Long = 0, Optional protStatus As Boolean = True)
'.------------------------------------------------------------------------------
'.  Funktion :  Sendet eine Zeichenfolge an ein Programm.
'.              Ruft die Funktion SendDOSKeys auf und protokolliert den Aufruf
'.              bei Bedarf.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: DOSString           - Enthlt die Zeichenfolge, die an das Programm
'.                                   gesendet werden soll.
'.             KeyWaitMilliSeconds - Wartezeit nach jedem Tastendruck
'.             protStatus          - True  : Protokollieren an
'.                                 - False : Protokollieren aus
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 DoEvents
 If protStatus = True Then
  Status "'" & DOSString & "' an Anwendung gesendet."
 End If
 SendDOSKeys DOSString, KeyWaitMilliSeconds
 DoEvents
End Sub

Private Sub Status(txt As String)
'.------------------------------------------------------------------------------
'.  Funktion : Fgt einen Text in das Protokoll-Textbox ein.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: txt - Text der eingefgt werden soll
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 With txtStatus
  If Len(.Text) = 0 Then
    .Text = Now & ": " & txt
   Else
    .Text = .Text & vbCrLf & Now & ": " & txt
  End If
  .SelStart = Len(.Text)
 End With
End Sub
