VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Der Vorschlaghammer"
   ClientHeight    =   2910
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5175
   LinkTopic       =   "Form1"
   ScaleHeight     =   2910
   ScaleWidth      =   5175
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResult 
      Height          =   2535
      Left            =   2040
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   240
      Width           =   3015
   End
   Begin VB.CommandButton cmdRecord2 
      Caption         =   "Zweiter Datensatz"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   720
      Width           =   1695
   End
   Begin VB.CommandButton cmdRecord1 
      Caption         =   "Erster Datensatz"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1695
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'// API
Private Const PROCESS_ALL_ACCESS& = &H1F0FFF
Private Const WAIT_FAILED = -1
Private Const INFINITE = &HFFFF
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

'// Ereignisse
Private Sub cmdRecord1_Click()
    ' Externes Dos-Programm starten und Eingabe "adr[Eingabe]1" absetzen
    Execute "adr" & GetKey(vbKeyReturn) & "1"
End Sub

Private Sub cmdRecord2_Click()
    ' Externes Dos-Programm starten und Eingabe "adr[Eingabe]2" absetzen
    Execute "adr" & GetKey(vbKeyReturn) & "2"
End Sub




Private Function GetKey$(cmd As KeyCodeConstants)
    GetKey = Chr$(cmd)
End Function

Private Sub Execute(InputStr As String)
    Const FILE_IN = "c:\fibu\in.txt", FILE_OUT = "c:\fibu\out.txt"
    Dim fileNr%, ab() As Byte, n&
    
    ' Steuerelemente sperren
    Me.cmdRecord1.Enabled = False
    Me.cmdRecord2.Enabled = False

    ' Eingabe in Datei speichern
    fileNr = FreeFile
    Open FILE_IN For Binary Access Write As #fileNr
        Put #fileNr, , InputStr
    Close #fileNr


    ' Programm starten, Standardein- und -ausgabe in Dateien umleiten
    WaitOnProg Shell("c:\fibu\Lief-adr.exe <" & FILE_IN & " >" & FILE_OUT, vbHide)
    
    ' Ausgabedatei einlesen
    Open FILE_OUT For Binary Access Read As #fileNr
        n = LOF(fileNr)
        If n > 0 Then ReDim ab(n - 1)
        Get #fileNr, , ab()
    Close #fileNr
    
    ' Ausgabedatei untersuchen und Ergebnis in ein Textfeld anzeigen
    If n > 0 Then Me.txtResult = InspectFile(ab())

    ' Aufrumen
    Kill FILE_IN
    Kill FILE_OUT

    ' Steuerelemente freigeben
    Me.cmdRecord1.Enabled = True
    Me.cmdRecord2.Enabled = True
End Sub

'/ Ausgabedatei untersuchen und relevante Daten herausschneiden
Private Function InspectFile$(ab() As Byte)
    Dim abRslt() As Byte, c&, n&, lb&, ub&
    
    n = UBound(ab()) + 1

    ' Dritten Zeilenumbruch beginnend vom Ende der Datei suchen
    Do Until n = 0 Or c = 3
        n = n - 1
        If ab(n) = &HA Then c = c + 1
    Loop
    ub = n
    
    ' Zehnten Zeilenumbruch beginnend vom Ende der Datei suchen
    Do Until n = 0 Or c = 10
        n = n - 1
        If ab(n) = &HA Then c = c + 1
    Loop

    ' Die ersten drei aufeinanderfolgenden Leerzeichen suchen
    Do Until n = 2 Or c = 11
        n = n - 1
        If ab(n) = &H20 Then
            If ab(n - 1) = &H20 Then If ab(n - 2) = &H20 Then c = c + 1
        End If
    Loop
    lb = n + 1

    ' Herauskopieren
    c = ub - lb
    If c > 0 Then
        ReDim abRslt(c * 2 + 1)
        For c = 0 To c
            abRslt(c * 2) = ab(lb + c)
        Next c
    
        InspectFile = abRslt()
    End If
End Function

'/ Auf das Ende eines externen Prozesses warten
Private Function WaitOnProg&(ByVal ProgID&)
    Dim iExit&, hProg&

    ' Prozess-Zugriffsnummer ermitteln.
    hProg = OpenProcess(PROCESS_ALL_ACCESS, False, ProgID)
    
    ' Funktion verlassen bei ungltiger ProgID oder falls der Prozess bereits beendet ist.
    If hProg = 0 Then WaitOnProg = -1: Exit Function
    
    ' Auf Ende des Prozesses warten
    If WaitForSingleObject(hProg, INFINITE) = WAIT_FAILED Then Err.Raise Err.LastDllError

    ' Rckgabewert ermitteln
    GetExitCodeProcess hProg, iExit

    CloseHandle hProg
    WaitOnProg = iExit
End Function
 
